#include<Arduino.h>
#include<SanyoCCB.h>
//LC7213IN1, byte 0
#define IN10_P0 0
#define IN10_P1 1
#define IN10_P2 2
#define IN10_P3 3
#define IN10_P4 4
#define IN10_P5 5
#define IN10_P6 6
#define IN10_P7 7
//LC7213IN1, byte 1
#define IN10_P8 0
#define IN10_P9 1
#define IN10_P10 2
#define IN10_P11 3
#define IN10_P12 4
#define IN10_P13 5
#define IN10_P14 6
#define IN10_P15 7
// LC72131 IN1, byte 2
#define IN10_R3     7
#define IN10_R2     6
#define IN10_R1     5
#define IN10_R0     4
#define IN10_XS     3
#define IN10_CTE    2
#define IN10_DVS    1
#define IN10_SNS    0
// LC72131 IN2, byte 0
#define IN20_TEST2  7
#define IN20_TEST1  6
#define IN20_TEST0  5
#define IN20_IFS    4
#define IN20_DLC    3
#define IN20_TBC    2
#define IN20_GT1    1
#define IN20_GT0    0

// LC72131 IN2, byte 1
#define IN21_DZ1    7
#define IN21_DZ0    6
#define IN21_UL1    5
#define IN21_UL0    4
#define IN21_DOC2   3
#define IN21_DOC1   2
#define IN21_DOC0   1
#define IN21_DNC    0

// LC72131 IN2, byte 2
#define IN22_BO4    7
#define IN22_BO3    6
#define IN22_BO2    5
#define IN22_BO1    4
#define IN22_IO2    3
#define IN22_IO1    2
#define IN22_IOC2   1
#define IN22_IOC1   0

// LC72131 DO0, byte 0
#define DO0_IN2     7
#define DO0_IN1     6
#define DO0_UL      4

// For function LC72131SetMode
#define LC72131_MONO    1
#define LC72131_STEREO  2
#define LC72131_MUTE    3
#define LC72131_UNMUTE  4
#define LC72131_BAND_FM 5
#define LC72131_BAND_AM 6





SanyoCCB Radioccb(A2, A3, A1, A0); // Pins: DO CL DI CE

byte pll_in1[3];
byte pll_in2[3];

// Initial frequencies
uint16_t FMFrequency = 949;   // MHz * 10
uint16_t AMFrequency = 53;    // KHZ / 10

uint8_t band = LC72131_BAND_FM;
uint8_t tuned = 0;
int cuk=0;
int pvk=0;

//************************************************
 //              LC72131Init()                   
 // Initialize the PLL settings vectors with     
 //parameters common to booth AM and FM modes   
//************************************************
void LC72131Init() {
  memset(pll_in1, 0, 3);
  memset(pll_in2, 0, 3);
  bitSet(pll_in2[0], IN20_IFS);   // IF counter in normal mode
  bitSet(pll_in2[1], IN21_UL0);   // Phase error detection width = 0us
  bitSet(pll_in2[2], IN22_BO4);   // Mute off / normal tuner mode
}

/************************************************\
 *              LC72131SetMode()                 
 * Some predefined setups for the LC72131 module 
\************************************************/
void LC72131SetMode(uint8_t mode) {
  switch(mode) {
    case LC72131_STEREO:
      bitClear(pll_in2[2], IN22_BO3);
      break;

    case LC72131_MONO:
      bitSet(pll_in2[2], IN22_BO3);
      break;

    case LC72131_MUTE:
    bitClear(pll_in2[2], IN22_BO4);
      break;

    case LC72131_UNMUTE:
      bitSet(pll_in2[2], IN22_BO4);
      break;

    case LC72131_BAND_FM:
      band = LC72131_BAND_FM; 
     // bitWrite(pll_in1[0], IN10_SNS , 0); // 
      bitWrite(pll_in1[0], IN10_DVS, 1);  
      bitWrite(pll_in1[0], IN10_CTE , 1); 
      bitWrite(pll_in1[0], IN10_XS, 1); // 
      bitWrite(pll_in1[0], IN10_R0,  1); // 
      bitWrite(pll_in1[0], IN10_R1,  0); // 
      bitWrite(pll_in1[0], IN10_R2,  0); //
      bitWrite(pll_in1[0], IN10_R3,  0); //
     
        bitWrite(pll_in2[2], IN22_IOC1, 1);
        bitWrite(pll_in2[2], IN22_IOC2, 1);
        bitWrite(pll_in2[2], IN22_IO1, 1);
        bitWrite(pll_in2[2], IN22_IO2, 0); // 
        bitWrite(pll_in2[2], IN22_BO1, 0); // 
        bitWrite(pll_in2[2], IN22_BO2, 0); // 
        bitWrite(pll_in2[2], IN22_BO3, 0); // 
        bitWrite(pll_in2[2], IN22_BO4, 0); 
        //
        bitWrite(pll_in2[1], IN21_DNC , 1); //
        bitWrite(pll_in2[1], IN21_DOC0 , 1); // 
        bitWrite(pll_in2[1], IN21_DOC1 , 0); //
        bitWrite(pll_in2[1],  IN21_DOC2, 0); // 
        bitWrite(pll_in2[1], IN21_UL0 , 1);
       bitWrite(pll_in2[1], IN21_UL1 , 0);
       bitWrite(pll_in2[1], IN21_DZ0  , 1);///////
       bitWrite(pll_in2[1], IN21_DZ1 , 0);
        //
        bitWrite(pll_in2[0],  IN20_GT0   , 0);
        bitWrite(pll_in2[0],  IN20_GT1   , 1);//////////
        bitWrite(pll_in2[0],  IN20_TBC   , 0);
        bitWrite(pll_in2[0],  IN20_DLC   , 0);
        bitWrite(pll_in2[0],   IN20_IFS   , 0);
        bitWrite(pll_in2[0],  IN20_TEST0  , 0);
        bitWrite(pll_in2[0],  IN20_TEST1  , 0);
       bitWrite(pll_in2[0],  IN20_TEST2  , 0);
         
      break;
    
    case LC72131_BAND_AM:
      band = LC72131_BAND_AM;
     bitWrite(pll_in1[0], IN10_SNS , 1); // 
      bitWrite(pll_in1[0], IN10_DVS, 0); // 
      bitWrite(pll_in1[0], IN10_CTE , 0); // 
      bitWrite(pll_in1[0], IN10_XS, 0); // 
      bitWrite(pll_in1[0], IN10_R0,  0); // 
      bitWrite(pll_in1[0], IN10_R1,  0); // 
      bitWrite(pll_in1[0], IN10_R2,  0); //
      bitWrite(pll_in1[0], IN10_R3,  1); //
     
        bitWrite(pll_in2[2], IN22_IOC1, 1);
        bitWrite(pll_in2[2], IN22_IOC2, 1);
        bitWrite(pll_in2[2], IN22_IO1, 1);
        bitWrite(pll_in2[2], IN22_IO2, 0); // 
        bitWrite(pll_in2[2], IN22_BO1, 1); // 
        bitWrite(pll_in2[2], IN22_BO2, 0); // 
        bitWrite(pll_in2[2], IN22_BO3, 0); // 
       bitWrite(pll_in2[2], IN22_BO4, 0); 
        //
        bitWrite(pll_in2[1], IN21_DNC , 1); //
        bitWrite(pll_in2[1], IN21_DOC0 , 1); // Dead zone = DZB
        bitWrite(pll_in2[1], IN21_DOC1 , 0); //
        bitWrite(pll_in2[1],  IN21_DOC2, 0); // AM mode
        bitWrite(pll_in2[1], IN21_UL0 , 0);
       bitWrite(pll_in2[1], IN21_UL1 , 0);
       bitWrite(pll_in2[1], IN21_DZ0  , 0);
       bitWrite(pll_in2[1], IN21_DZ1 , 1);
        //
        bitWrite(pll_in2[0],  IN20_GT0   , 1);
        bitWrite(pll_in2[0],  IN20_GT1   , 0);
        bitWrite(pll_in2[0],  IN20_TBC   , 0);
        bitWrite(pll_in2[0],  IN20_DLC   , 0);
        bitWrite(pll_in2[0],   IN20_IFS   , 0);
        bitWrite(pll_in2[0],  IN20_TEST0  , 0);
        bitWrite(pll_in2[0],  IN20_TEST1  , 0);
       bitWrite(pll_in2[0],  IN20_TEST2  , 0);
      break;
  }
  Radioccb.write(B10000010, pll_in1, 3 );
  Radioccb.write(B10010010, pll_in2, 3); 
}



/************************************************************\
                        LC72131Tune()                       
  Set the tuner frequency and return 1 if it is tuned      
  or 0 otherwise.                                          
                                                           
  The frequency divisors was chosen in a way the frequency 
  representation can be directly sent to the PLL and is    
  easy to represent:                                       
   FM mode (divisor = 100): frequency (MHz) * 10          
   AM mode (divisor = 10):  frequency (kHZ) / 10          
\************************************************************/
uint8_t LC72131Tune(uint16_t frequency) {
  uint16_t fpd = 0;

 // unsigned long IFCounter = 0;
  
  switch(band) {
    case LC72131_BAND_FM:
      // FM: fpd = (frequency + FI) / (50 * 2)
      fpd = (frequency + 107);
      break;
      
    case LC72131_BAND_AM:
      // AM: fpd = ((frequency + FI) / 10) << 4
      fpd = (frequency + 45) << 4;
      break;
      
    default: return 1;
  }

  LC72131SetMode(LC72131_MUTE);   // LC72131 only injects FI signal into the PLL when in MUTE mode

  // Reset the IF counter and program the Frequency Programmable Divider (fpd)
  bitClear(pll_in1[0], IN10_CTE);
  pll_in1[1] = byte(fpd >> 8);

  pll_in1[2] = byte(fpd & 0x00ff);

Radioccb.write(B10000010, pll_in1, 3 );

  // Start the IF counter
  bitSet(pll_in1[0], IN10_CTE);
Radioccb.write(B10000010, pll_in1, 3 );


  
 LC72131SetMode(LC72131_UNMUTE);   // Mute off / normal tuner mode


  return 0; 
}